#ifndef XMEDIA_NETWORKCONFIG_H
#define XMEDIA_NETWORKCONFIG_H

#include <QObject>
#include <QProcess>
#include <QMap>

typedef struct{
    QString essid;
    QString frequency;
    QString accessPoint;
    int linkQuality;
    QString linkSignalLevel;
    QString linkNoiseLevel;
    QString bitRate;
    QString txPower;
    QString secKey;
    QString secMode;
} xmedia_networkConfigWifiStatus;

typedef struct{
    QString name;
    QString mac;
    QString ip;
    QString subnet;
    QString gateway;
    long bytesRX;
    long bytesTX;
} xmedia_networkConfigNetworkStatus;


class xmedia_networkConfig : public QObject
{
public:
    xmedia_networkConfig();
    QList<xmedia_networkConfigWifiStatus> wifiAvailableNetworks();
    void wifiConfigureNetwork(QString interface, QString essid, QString key, QString datarate);
    xmedia_networkConfigWifiStatus wifiNetworkStatus();

    QList<xmedia_networkConfigNetworkStatus> networkStatus();
    void networkConfigure(QString interface, bool useDhcp, QString ip, QString subnet, QString gateway, QString dns);

private:
    QString getProcessResult(QString process);
    QString extractString(QString data, QString before, QString after);

};

#endif // XMEDIA_NETWORKCONFIG_H
